/**
 * Copyright (c) 2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.admin;

import java.util.ArrayList;
import java.util.List;

import org.ow2.petals.admin.api.artifact.Artifact;

/**
 * 
 * @author "Mathieu CARROLLE - EBM WebSourcing"
 * 
 */
public class ArtifactDirectoryMock {

    private static ArtifactDirectoryMock instance = new ArtifactDirectoryMock();

    protected static ArtifactDirectoryMock getInstance() {
        return instance;
    }

    private final List<Artifact> artifacts;

    private ArtifactDirectoryMock() {
        this.artifacts = new ArrayList<Artifact>();
    }

    protected boolean add(Artifact a) {
        return artifacts.add(a);
    }

    protected boolean remove(Artifact a) {
        boolean removed = false;
        for (Artifact item : artifacts) {
            if (item.getName().equals(a.getName()) && item.getType().equals(a.getType())) {
                artifacts.remove(item);
                break;
            }
        }
        return removed;
    }

    protected Artifact[] list() {
        Artifact[] a = new Artifact[artifacts.size()];
        return artifacts.toArray(a);
    }
    
    protected Artifact get(Artifact a) {
        for (Artifact artifact : artifacts) {
            if(artifact.equals(a))
                return artifact;
        }
        return null;
    }
}
