/**
 * Copyright (c) 2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.admin.junit;

import org.ow2.petals.admin.api.artifact.Component;
import org.ow2.petals.admin.api.artifact.ServiceAssembly;
import org.ow2.petals.admin.api.artifact.SharedLibrary;
import org.ow2.petals.admin.api.artifact.lifecycle.ArtifactLifecycleFactory;
import org.ow2.petals.admin.api.artifact.lifecycle.ComponentLifecycle;
import org.ow2.petals.admin.api.artifact.lifecycle.ServiceAssemblyLifecycle;
import org.ow2.petals.admin.api.artifact.lifecycle.SharedLibraryLifecycle;
import org.ow2.petals.admin.topology.Container;

/**
 * 
 * @author "Mathieu CARROLLE - EBM WebSourcing"
 * 
 */
public class ArtifactLifecycleFactoryMock extends ArtifactLifecycleFactory {

    /**
     * Container on which the Petals Administration API is connected
     */
    private final Container container;

    public ArtifactLifecycleFactoryMock(final Container container) {
        this.container = container;
    }

    @Override
    public ComponentLifecycle createComponentLifecycle(final Component c) {
        return new ComponentLifecycleMock(c, this.container);
    }

    @Override
    public ServiceAssemblyLifecycle createServiceAssemblyLifecycle(final ServiceAssembly sa) {
        return new ServiceAssemblyLifecycleMock(sa, this.container);
    }

    @Override
    public SharedLibraryLifecycle createSharedLibraryLifecycle(final SharedLibrary sl) {
        return new SharedLibraryLifecycleMock(sl, this.container);
    }

}
