/**
 * Copyright (c) 2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.admin.junit.utils;

import java.util.HashMap;
import java.util.Map;

import org.ow2.petals.admin.topology.Container;
import org.ow2.petals.admin.topology.Container.PortType;
import org.ow2.petals.admin.topology.Container.State;

public class ContainerUtils {

    final public static String CONTAINER_NAME = "my-container";

    final public static String CONTAINER_HOST = "localhost";

    final public static int CONTAINER_JMX_PORT = 12345;

    final public static String CONTAINER_USER = "my-container-user";

    final public static String CONTAINER_PWD = "my-container-pwd";

    final public static State CONTAINER_STATE = State.REACHABLE;

    /**
     * Create a sample container with the following definition:
     * <ul>
     * <li>container name: {@value #CONTAINER_NAME}</li>
     * <li>hostname: {@value #CONTAINER_HOST}</li>
     * <li>JMX port: {@value #CONTAINER_JMX_PORT}</li>
     * <li>JMX username: {@value #CONTAINER_USER}</li>
     * <li>JMX password: {@value #CONTAINER_PWD}</li>
     * </ul>
     */
    public final static Container createContainerSample() {
        final Map<PortType, Integer> ports = new HashMap<PortType, Integer>();
        ports.put(PortType.JMX, Integer.valueOf(CONTAINER_JMX_PORT));
        return new Container(CONTAINER_NAME, CONTAINER_HOST, ports, CONTAINER_USER, CONTAINER_PWD,
                CONTAINER_STATE);
    }

}
